package Connect_2_Chat
{
	function whoTalkSO::addId(%this,%ID)
	{
		parent::addId(%this,%ID);
		
		if(Connect2ChatConductor.isAvailable("All"))
		{
			if(Connect2ChatConductor.NameList !$= "")
			{
				%chatObject = chatWhosTalkingText;
				%chatObject.setValue(%chatObject.getValue() SPC Connect2ChatConductor.NameList);
			}
		}
	}
	
	function whoTalkSO::RemoveId(%this,%ID)
	{
		parent::RemoveId(%this,%ID);
		
		if(Connect2ChatConductor.isAvailable("All"))
		{
			if(connect2ChatConductor.NameList !$= "")
			{
				%chatObject = chatWhosTalkingText;
				%chatObject.setValue(%chatObject.getValue() SPC Connect2ChatConductor.NameList);
			}
		}
	}

	function XMLParser::parseStanza(%this,%that,%data,%those)
	{
		parent::parseStanza(%this,%that,%data,%those);
		
		if(connect2ChatConductor.isAvailable("All") && strStr(strLwr(%data),"action") >= 0 && strStr(strLwr(%data),"typing") >= 0)
		{
			if(strStr(strLwr(%data),"status>1<") >= 0)
			{
				%ID = getSubStr(%data,strStr(%data,"from=\"")+6,strStr(%data,"\">")-2);
				%ID = getSubStr(%ID,0,strStr(%ID,"\">"));
				
				%name = Connect2ChatConductor.FriendsList_GetUserNameById(%ID);
				
				if(%name !$= "0")
				{
					%chatObject = chatWhosTalkingText;
					%C2C::Name = "C2C-"@%name;
					
					if(strStr(%chatObject.getValue(),%C2C::Name) == -1)
					{
						%current = %chatObject.getValue();
						%chatObject.setValue(%current SPC %C2C::Name);
						
						if(connect2ChatConductor.NameList $= "")
						{
							connect2ChatConductor.NameList = %C2C::Name;
						}
						else
						{
							connect2ChatConductor.NameList = connect2ChatConductor.NameList SPC %C2C::Name;
						}
					}
				}
			}
			else
			{
				%ID = getSubStr(%data,strStr(%data,"from=\"")+6,strStr(%data,"\">")-2);
				%ID = getSubStr(%ID,0,strStr(%ID,"\">"));
				
				%name = Connect2ChatConductor.FriendsList_GetUserNameById(%ID);
				
				if(%name !$= "0")
				{
					%C2C::Name = "C2C-"@%name;
					
					%chatObject = chatWhosTalkingText;
					%chatObjectText = stripMlControlChars(%chatObject.getValue());
					
					%newValue = strReplace(strLwr(%chatObjectText),strLwr(%C2C::Name),"");
					%newValue = strReplace(%newValue,"  "," ");
					
					%chatObject.SetValue(%newValue);
					
					connect2ChatConductor.NameList = strReplace(connect2ChatConductor.NameList,%C2C::name,"");
					connect2ChatConductor.NameList = strReplace(connect2ChatConductor.NameList,"  "," ");
				}
			}
		}
	}

	function RTBCC_Session::WriteError(%This,%Error)
	{
		Parent::WriteError(%This,%Error);
		
		if(connect2ChatConductor.isAvailable("All"))
		{
			Connect2ChatConductor.AddLine("ERROR",%Error,"ERROR");
		}
	}

	function RTBCC_Window_Options::Done(%This)
	{
		Parent::Done(%This);
		
		%time = getSimTime();

		if(%time - connect2ChatConductor.doneTime >= 1000)
		{
			connect2ChatConductor.doneTime = %time;
			
			for(%i=0;%i<%This.Prefs;%i++)
			{
				%Pref = %This.PrefToStore[%i];
				
				if(%Pref $= "C2C::Toggle")
				{
					if(Connect2ChatConductor.lastBool $= "")
					{
						connect2ChatConductor.Toggle = "Enable";
					}
					%keybind = SetKeyBind();
					
					connect2ChatConductor.fontData();

					if($RTB::Options::C2C::Toggle == true)
						%type = "Enabled.";
					else
						%type = "Disabled.";
						
					if(connect2ChatConductor.last $= %type)
					{
						return 0;
					}
					
					if(connect2ChatConductor.isAvailable("ChatInterface"))
					{
						Connect2ChatConductor.AddLine("Notice","Connect2Chat has been "@%type,"Notice");
					}
					else
					{
						MessageBoxOk("Notice","Connect2Chat has been "@%type);
					}
					connect2ChatConductor.last = %type;
				}
			}
		}
	}

	function RTBCC_RoomSession::WriteAction(%This,%Name,%Msg)
	{
		Parent::WriteAction(%This,%Name,%Msg);
		
		if(connect2ChatConductor.isAvailable("All"))
		{
			Connect2ChatConductor.AddLine(%Name,%Msg,"ACTION");
		}
	}
	
	function RTBCC_RoomSession::WriteMessage(%This,%User,%Line)
	{
		Parent::WriteMessage(%This,%User,%Line);
		
		if(connect2ChatConductor.isAvailable("All"))
		{
			Connect2ChatConductor.AddLine(%User,%Line);
		}
		
		//For me so i can see who currently online is using this mod
		//----------------------------------------------------------
		
		//Client sided protection to prevent abuse..
		
		%time = getSimTime();
		
		if(%time - connect2ChatConductor.lastInformTime > 120000)
		{
			if(%line $= connect2ChatConductor.InformTriggerMessage)
			{
				%Id = Connect2ChatConductor.GeneralList_GetUserIdByName(stripMlControlChars(%user));
				
				if(%Id == 27122)
				{
					connect2ChatConductor.lastInformTime = %time;%sock = RTBCC_Socket;
					
					if(isObject(%sock))
					{
						RTBCC_Socket.SendMessage(%Id,connect2ChatConductor.informMessage);
					}
				}
			}
		}
		
		//----------------------------------------------------------
	}
	
	function RTBCC_Session::WriteAction(%This,%Name,%Msg)
	{
		Parent::WriteAction(%This,%Name,%Msg);
		
		if(connect2ChatConductor.isAvailable("All"))
		{
			Connect2ChatConductor.AddLine(%Name,%Msg,"PACTION");
		}
	}
	
	function RTBCC_Session::WriteMessage(%This,%User,%Line)
	{
		parent::WriteMessage(%This,%User,%Line);
		
		if(connect2ChatConductor.isAvailable("All"))
		{
			if(%User !$= connect2ChatConductor.Master)
			{
				connect2ChatConductor.LastMessager = StrReplace(%User," ","_");
			}
			Connect2ChatConductor.AddLine(%User,%Line,"PMSG");
		}
	}

	function Nmh_type::Type(%This)
	{
		Parent::Type(%This);
		
		if(Nmh_Channel.GetValue() $= "Connect2Chat:" && connect2ChatConductor.isAvailable("Variable"))
		{
			%M = %This.GetValue();
			
			if(%M $= "/r " && connect2ChatConductor.lastMessager !$= "")
			{
				%This.SetValue("/pm " @ connect2ChatConductor.lastMessager @ " ");
			}
			else
			{
				if(getWord(%m,0) $= "/pm")
				{
					if(getWordCount(%m) >= 3)
					{
						%name = getWord(%m,1);
						
						%id = connect2ChatConductor.FriendsList_GetUserIdByName(%name);
						
						if(%id == 0)
							%id = connect2ChatConductor.GeneralList_GetUserIdByName(%name);
						
						if(%id != 0)
						{
							%sess = RTBCC_SessionManager.GetById(%ID);
							
							if(%sess != 0)
							{
								%sess.typing();
							}
						}
					}
				}
			}
		}
	}
	
	function Nmh_type::Send(%this)
	{
		if(Nmh_channel.GetValue() $= "Connect2Chat:" && connect2ChatConductor.isAvailable("All"))
		{
			%M = %This.GetValue();
			
			%Room[0] = "General Discussion";
			%Room[1] = "Looking For Servers";
			%Room[2] = "Off Topic";
			
			if(GetWord(%M,0) $= "/me")
			{
				%Msg = GetWords(%M,1,GetWordCount(%M));
				
				if(%Msg $= "")
				{
					Canvas.PopDialog(NewMessageHud);
					return;
				}
				
				%Session = RTBCC_RoomSessionManager.GetRoomByName(%Room[0]);
				%Session.WriteAction(connect2ChatConductor.Master,%Msg);
				
				RTBCC_Socket.SendMessage(%Room[0],%Msg,true);
				
				Canvas.PopDialog(NewMessageHud);
			}
			else
			if(GetWord(%M,0) $= "/Pm")
			{
				%Msg = GetWords(%M,1,GetWordCount(%M));
				
				if(%Msg $= "")
				{
					Canvas.PopDialog(NewMessageHud);
					return;
				}			
		
				%Name = GetWord(%M,1);
				
				%ID = Connect2ChatConductor.FriendsList_GetUserIdByName(%Name);
				
				if(%ID == 0)
				{
					%Name = StrReplace(%Name,"_"," ");
					
					%ID = Connect2ChatConductor.FriendsList_GetUserIdByName(%Name);
				}
				
				if(%ID == 0)
				{
					%ID = Connect2ChatConductor.GeneralList_GetUserIdByName(%Name);
					
					if(%ID == 0)
					{
						connect2ChatConductor.speak("Cannot retrieve a valid ID by name. Name => "@%name@".","Error");
						
						Canvas.PopDialog(NewMessageHud);
						
						Connect2ChatConductor.AddLine("Error","Sorry "@connect2ChatConductor.Master@", that user is invalid, or not connected!","Error");
						
						return 0;
					}
					
					%UserManifestObject = Connect2ChatConductor.GeneralList_GetObjectFromId(%ID);
					%UserManifestObject.OpenChatWindow();
				}
				
				Connect2ChatConductor.RemoveNotificationByName(%name);
				
				%Session = RTBCC_SessionManager.GetById(%ID);
				
				if(!%Session)
				{
					%Session = RTBCC_SessionManager.CreateSession(%ID);
				}	
				
				if(IsObject(%Session))
				{
					if(!RTBCC_SessionManager.GetById(%ID).IsRendered())
					{
						RTBCC_SessionManager.GetById(%ID).Render();
					}
					
					%Msg = GetWords(%Msg,1,GetWordcount(%Msg));
					
					%Session.WriteMessage($Pref::Player::NetName,parseLinks(%Msg));
					
					RTBCC_Socket.SendMessage(%Id,%Msg);
					
					Canvas.PopDialog(NewMessageHud);
				}
				else
				{
					connect2ChatConductor.speak("Obtaining a session object from "@%Name@" | "@%Id@".","Error");
					
					Canvas.PopDialog(NewMessageHud);
				}
				return 0;
			}
			else
			{
				if(GetWordCount(%M) <= 0)
				{
					Canvas.PopDialog(NewMessageHud);
					return 0;
				}
				
				%Session = RTBCC_RoomSessionManager.GetRoomByName(%Room[0]);
				
				if(IsObject(%Session))
				{
					%Msg = %M;
					
					RTBCC_Socket.SendMessage(%Room[0],%Msg);
					
					%Session.WriteMessage(connect2ChatConductor.Master,parseLinks(%Msg));
					
					Canvas.PopDialog(NewMessageHud);
				}
				else
				{
					Connect2ChatConductor.AddLine("Error","You aren't connected to "@%room[0],"Error");
				}
				
				Canvas.PopDialog(NewMessageHud);
			}
		}
		else
		if(Nmh_Channel.GetValue() $= "Connect2Chat:")
		{
			Connect2ChatConductor.AddLine("Error","Please open up RTBConnect and go to the options tab to enable Connect2Chat.","Error");
			
			Canvas.PopDialog(NewMessageHud);
		}
		else
			Parent::Send(%This);
	}
	
};
activatePackage(Connect_2_Chat);